var errTimer;
var bgContainer;
var formContainer;
var opContainer;
var noticeContainer;
var statusExecutor;
var errCounter = 0;

$(function () {
    bgContainer = $('.bgContainer');
    formContainer = $('.formContainer');
    opContainer = $('.opContainer');
    noticeContainer = $('#notice');
	
	getCloseTipsListener();
	
	// 支持延续原升级流程
	doAjax('isRunning', {}, function (data) {
		"true" === data.data ? showTargetContainer("showExecution") : showTargetContainer("showPatchInfo");
	});
});

// 显示对应面板
function showTargetContainer(data) {
    // 隐藏操作区
    opContainer.addClass('hidden');
    opContainer.find('button').remove();
    //bgContainer.css('height', '94.8%');

    // 隐藏提示区
    noticeContainer.addClass('hidden');

    if (data === "showPatchInfo") {
        showPatchInfo()
    } else if (data === "showValidation") {
        // showValidation()
    } else if (data === "showExecution") {
        showExecution()
    }
}

// 更新说明
function showPatchInfo() {
    formContainer.html($('<div class="patch_container" id="showPatchInfo">' +
        '<div class="plain_title"><span>补丁升级确认</span></div>' +
        '<div class="part">' +
        '<div class="part_container part_patch">' +
        '<div class="part_title">' +
        '<span>补丁说明</span>' +
        '</div>' +
        '<div class="part_desc">' +
        '<span>正在获取补丁描述...</span>' +
        '</div>' +
        '</div>' +
        '</div>' +
        '</div>'));

    opContainer.find('button').remove();
	getCancelListener('暂不升级');
    getNextStepListener('showExecution');
    showInfo(function (info) {
        var $desc = $('.part_desc').empty();
        var content = info.content;
        if (content === undefined || content === null) {
            $desc.append('<div class="patch_details" style="margin-top:15px;">暂无详细描述</div>');
        } else {
            // time
            $desc.append('<div class="patch_name patch_summary"></div>')
            var $summary = $desc.find('.patch_summary')
            $summary.append('<div class="patch_details">发布时间：' + info.timeInfo + '</div>');

            // version
            $summary.append('<div class="patch_details patch_version">产品版本：</div>');
            var $version = $summary.find('.patch_version')
            $.each(info.products, function (i, item) {
                var versionInfo = item.productName + '(' + item.productNumber + ')' + "：" + item.productVersion
                $version.append('<div class="patch_details" style="text-indent: 5em;">' + versionInfo + '</div>')
            })

            // content
            var list = info.content.split('\n')
            $desc.append('<div class="patch_name">' + list[0] + '</div>')
            $.each(list, function (i, item) {
                if (i > 0) $desc.append('<div class="patch_details" style="word-wrap:break-word;">' + item + '</div>');
            })
        }
    })
}

// 触发自升级
function showExecution() {
    formContainer.html($('<div class="execute_container" id="showExecution">' +
        '<div class="plain_title"><span>正在升级中，请稍后</span></div>' +

        // 进度条
        '<div class="progress_container">' +
        '<div class="progress_wrapper">' +
        '<div class="progress_active"></div>' +
        '</div>' +
        '<div class="progress_desc">0%</div>' +
        '</div>' +

        // 环境检测
        '<div class="part">' +
        '<div class="part_container part_env">' +
        '<div class="part_title">' +
        '<span>环境信息检测</span>' +
        '<div class="part_result"><span class="blue">检测中</span></div>' +
        //'<div class="part_result"><span class="green">检测通过</span></div>' +
        '</div>' +
        '<div class="part_desc">' +
		'<div class="load_desc" style="display:flex;">' +
        '<span>正在获取检测信息...</span>' +
		'<div class="load_ring"/>'+
		'</div>' +
        // '<div>当前MC版本：5.0.003</div>' +
        // '<div>升级目标版本：5.0.020</div>' +
        '</div>' +
        '</div>' +
        '</div>' +

        // 升级过程
        '<div class="part">' +
        '<div class="part_container part_update">' +
        '<div class="part_title">' +
        '<span>管理中心升级</span>' +
        // '<div class="part_result"><span class="blue">查看详情</span></div>' +
        '</div>' +
        '<div class="part_desc">' +
        //'<span>正在获取升级状态...</span>' +
        '</div>' +
        '</div>' +
        '</div>' +
        '</div>'));

    // 环境检测后触发
    showValidation(function () {
        showInfo(function (info) {
            clearInterval(statusExecutor);	// 轮询
            statusExecutor = setInterval(function () {
                getSegInfo(info.updateId);
            }, 1000);

			getResultListener(info.updateId);
        });
    });
}

// 查看详情
function getResultListener(updateId) {
	if (!updateId) return;
	var $btn = $('<div class="part_result"><span class="blue">查看详情</span></div>');
	$btn.click(function () {
        window.open('?selfUpdateLogs=true&updateId=' + updateId);
    });
	
	var $container = $('.part_update');
	$container.find('.part_result').remove();
	$container.find('.part_title').append($btn);
}

// 环境检测
function showValidation(callback) {
	showInfo(function (info) {
		setTimeout(function() {
			var $result = $('.part_env .part_result');
			var $desc = $('.part_env .part_desc').empty();
			var isSuccess = info.success;
			if (isSuccess === true) {
				$result.html('<span class="green">检测通过</span>');
				var versions = info.data;
				$.each(versions, function (i, item) {
					$desc.append('<div>' + item + '</div>');
				});
				$('.part_update .part_desc').html('<span>正在获取升级状态...</span>');
				if (callback) callback();
			} else {
				$result.html('<span class="red">检测失败</span>');
				$desc.append('<div>' + info.data + '</div>');
				$('.part_update .part_desc').html('<span>升级已停止</span>');
				showResult(true);
				getPrevStepListener('showPatchInfo');
				getRestartListener();
			}
		}, 1000);
    }, 'showValidation')
}

// 获取分步状态信息
function getSegInfo(updateId) {
    doAjax('showStatus', {updateId: updateId}, function (data) {
        if (!data.data) {
            showErrorNotification('获取升级数据失败，或本次升级信息不存在，请刷新重试。');
            return false;
        }

        var info = JSON.parse(data.data);
        showProgress(info.progress);	// 进度条
        showSegInfo(info);
    }, true)
}

// 显示分步状态信息
function showSegInfo(info) {
    if (!info.segments) return false;
    var hasFailed = false;
    // var hasFinished = true;

    // 清除原来信息
    var $desc = $('.part_update .part_desc').empty();

    var canShutdown = false;
    $.each(JSON.parse(info.segments), function (i, item) {
        // console.log(item)
        var processCode = item.processCode;
        var status = item.status;
        var updateId = item.updateId;

        // 结果超链日志
        var $result = $("<span class='status_result " + STATUS_COLOR[status] + "' id='" + processCode + "' data-update='" + updateId + "'>" + STATUS[status] + "</span>");
        var $step = $("<div class='tips_step'>" + DESC[processCode] + "</div>");
        $step.append($result);
        $desc.append($step);

        // 数据中心运行中才可终止
        if ("DATACENTER_UPDATE" === processCode) canShutdown = "RUNNING" === status;

        // if ("RUNNING" === status) hasFinished = false;	// 完成标记，存在执行中都是未完成
        if ("SUCCESS" !== status) hasFailed = true;	// 失败标记
    });

    // 升级完成停止轮询，并显示操作区
    if (hasFinished(info.status)) {
        showResult(hasFailed);
        clearInterval(statusExecutor);
		getCancelListener('关闭页面');
        if (!hasFailed) {
            getConfirmListener();
            alert("自升级已完成，为使新版本配置生效，请立即手动重启MC服务。");
        }
        else getRestartListener();
    } else {
		// 运行中可终止
		if (canShutdown) getShutdownListener(info.id);
	}
}

// 显示结果
function showResult(hasFailed) {
    var $active = $('.progress_active');
    var $wrapper = $('.progress_wrapper');
    var $desc = $('.progress_desc');
    var $title = $('.execute_container .plain_title span');

    if (hasFailed) {
        $title.text('升级失败');
		return;
    }
	
	$wrapper.css('width', '93%');
    $desc.css('width', '7%');
    $title.text('升级成功');
    $desc.html('<div class="progress_icon progress_success">√</div>');
    $active.removeClass('progress_running');
    $active.addClass('progress_success');
}

// 进度条控制
function showProgress(percent) {
    if (!percent) percent = 0;
    if (percent > 100) percent = 100;
    var desc = percent + '%';
    $('.progress_active').addClass('progress_running').animate({'width': percent + '%'}, 200);
    $('.progress_desc').html('<span class="progress_percent">' + desc + '</span>');
}

// 基础后端交互
function showInfo(callback, type) {
    if (!type) type = formContainer.children().attr("id");
    doAjax(type, {}, function (data) {
        // 其他操作
        var info = JSON.parse(data.data);
        if (callback) callback(info)
    });
}

// 关闭提示
function getCloseTipsListener() {
    $('#cancel').click(function () {
        clearTimeout(errTimer);
        noticeContainer.addClass('hidden')
    })
}

// 上一步
function getPrevStepListener(type) {
    var $prev = $('<button type="button" id="prevStep" class="btn-item" data-next="' + type + '">上一步</button>');
    $prev.click(function () {
        var target = $(this).data("next");
        showTargetContainer(target)
    });

    $("#prevStep").remove();
    opContainer.removeClass('hidden').append($prev);
}

// 确认升级
function getNextStepListener(type) {
    var $next = $('<button type="button" id="nextStep" class="btn-item" data-next="' + type + '">确认升级</button>');
    $next.click(function () {
        // validate
        var next = $(this).data("next");
        showTargetContainer(next);
    });

    $('#nextStep').remove();
    opContainer.removeClass('hidden').append($next);
}

// 停止升级
function getShutdownListener(updateId) {
	var $shutdown = $('<button type="button" id="shutdown" data-update="' + updateId + '" class="btn-item">停止升级</button>');
	$shutdown.click(function () {
		doAjax('stopExecution', {updateId: $(this).data('update')}, function () {
			showSuccessNotification('操作成功，升级已停止。');
		});
	});
	
	$('#shutdown').remove();
    opContainer.removeClass('hidden').append($shutdown);
	
	$('#restart').remove();		// 互斥按钮
}

// 暂不升级
function getCancelListener(title) {
	var $cancel = $('<button type="button" id="cancel" class="btn-item btn-close">' + title + '</button>');
	$cancel.click(function () {
		if (navigator.userAgent.indexOf("Firefox") !== -1 || navigator.userAgent.indexOf("Chrome") !== -1) {
			window.location.href = "about:blank";
			window.close();
		} else {
			window.opener = null;
			window.open("", "_self");
			window.close();
		}
	});
	
	$('#cancel').remove();
    opContainer.removeClass('hidden').append($cancel);
}

// 确认
function getConfirmListener() {
    var $confirm = $('<button type="button" id="confirm" class="btn-item">登录MC</button>');
    $confirm.click(function () {
        doAjax('finish', {}, function () {
            window.location.href = "login-mc.html";
        });
    });

    $('#confirm').remove();
    opContainer.removeClass('hidden').append($confirm);
	
	$('#shutdown').remove();	// 互斥按钮
}

// 重新升级
function getRestartListener() {
    var $confirm = $('<button type="button" id="restart" class="btn-item">重新升级</button>');
    $confirm.click(showExecution);

    $('#restart').remove();
    opContainer.removeClass('hidden').append($confirm);
	
	$('#shutdown').remove();	// 互斥按钮
}

// 显示进度条中的对应标识
// function showFlowContainer(data) {
// $(".stepContainer").removeClass("active");
// var step = $(".stepContainer[data-id=" + data + "]");
// if (step) step.addClass("active")
// }

// 抽象请求方法
function doAjax(type, params, successCallback, doNotShowLoading) {
    if (!params) params = {};
    params['type'] = type;
    $.ajax({
        type: 'POST',
        url: 'init/mdbSetting.do',
        data: params,
        beforeSend: function () {
            if (!doNotShowLoading) showLoading();
        },
        complete: hideLoading,
        error: function () {
			// 每10次弹出提示
			errCounter++;
			if (errCounter >= 10) {
				showErrorNotification("无法加载响应数据，可能MC服务中断或正在重启，请刷新重试。");
				errCounter = 0;
			}
		},
        success: function (data) {
            if (data.errorcode === "0") {
                clearInterval(statusExecutor);
                showErrorNotification(data.description_cn || data.description);
                return false
            }

            if (successCallback) successCallback(data);
        }
    })
}

// show loading
function showLoading() {
    $('.mask').removeClass('hidden')
}

// hide loading
function hideLoading() {
    $('.mask').addClass('hidden')
}

// 成功信息
function showSuccessNotification(msg) {
    noticeContainer.find("span").text(msg);
    noticeContainer.find(".icon").text("√");
    noticeContainer.attr("class", "noticeContainer success");

    clearTimeout(errTimer);
    errTimer = setTimeout(function () {
        noticeContainer.addClass('hidden')
    }, 3000)
}

// 报错信息
function showErrorNotification(msg) {
    noticeContainer.find("span").text(msg);
    noticeContainer.find(".icon").text("!");
    noticeContainer.attr("class", "noticeContainer error");
}

// 判断是否完成
function hasFinished(status) {
	return ['SUCCESS', 'FAILURE', 'TIMEOUT', 'TERMINATED'].indexOf(status) !== -1;
}

// 步骤描述字典
var DESC = {
    "APPSTORE_UPDATE": "应用仓库更新",
    "STATIC_RESOURCE": "静态资源更新",
    "DATACENTER_UPDATE": "数据中心升级"
};

// 状态描述字典
var STATUS = {
    "READY": "等待",
    "RUNNING": "执行中",
    "SUCCESS": "成功",
    "FAILURE": "失败",
    "TIMEOUT": "失败(超时)",
    "TERMINATED": "终止"
};

// 状态颜色
var STATUS_COLOR = {
    "READY": "grey",
    "RUNNING": "blue",
    "SUCCESS": "green",
    "FAILURE": "red",
    "TIMEOUT": "red",
    "TERMINATED": "red"
};