var errTimer;
var formContainer;
var noticeContainer;
var dmExecutor;
var otherExecutor;
var logExecutor;
var currentLogId;
var dmCounter = 0;
var otherCounter = 0;
var errCounter = 0;

$(function () {
    formContainer = $('.formContainer');
    noticeContainer = $('#notice');

	// 页面展示
    showCaption();
    showOtherLogs();
	showDmLogs();
	
	// 日志轮询
	doUpdateStatus();
	getCloseTipsListener();
});

// 页面元素展示
function showCaption() {
    formContainer.html('<div class="caption">管理中心升级详情</div>');
}

// 数据中心升级详情
function showDmLogs() {
    formContainer.append('<div class="dc_container" id="DATACENTER_UPDATE">' +
		'<div class="step_title">' + 
		'<span>数据中心升级</span>' + 
		'<div class="all_time">' + 
		'<span>升级总耗时：</span>' + 
		'<span class="time">未知</span>' + 
		'</div>' + 
		'</div>' +
		
        '<div class="dm_logs">' +
        '<div class="tr header">' +
        '<div class="th name">升级内容（元数据包名称）</div>' +
        '<div class="th status">升级状态</div>' +
        '<div class="th time">升级耗时</div>' +
        '<div class="th details">操作</div>' +
        '</div>' +
        '<div class="tbodyWrapper">' +
        '<div class="tbody">' +

        '</div>' +
        '</div>' +
		'</div>' +
        '</div>');
		
	doShowDms();
}

// 后端交互，用于轮询
function doShowDms(doNotShowLoading) {
	var $logs = $('.dm_logs .tbody');
	doAjax('showDms', {updateId: getParam('updateId')}, function (data) {
        if (!data.data) return false;
        var dms = JSON.parse(data.data);
		
		// 通过总状态终止轮询
		var dcStatus = $('.dm_logs').data('status');
		
		$logs.find('.body').remove();
        $.each(dms, function (i, item) {
            var status = item.status;
            var url = item.dmUrl;
            var dm = url.substring(url.lastIndexOf('/') + 1);
            var $tr = $('<div class="tr body">' +
                '<div class="td name" title="' + dm + '">' + dm + '</div>' +
                '<div class="td status" data-status="' + status + '" id="' + item.id + '"><span class="' + STATUS_COLOR[status] + '" title="' + STATUS[status] + '">' + STATUS[status] + '</span></div>' +
                '<div class="td time" data-start="' + item.createTime + '"></div>' +
                '<div class="td details"><span class="blue" title="查看详情" data-id="' + item.id + '" data-task="' + item.taskId + '">查看详情<span></div>' +
                '</div>');
            $logs.append($tr);
			
			// 时间
			var $time = $tr.find('.time');
			if (hasFinished(status)) $time.attr('data-end', item.modifyTime);
			setConsumingTime($time);

            // 查看详情
			var $details = $tr.find('.details .blue');
			if (!item.id || !item.taskId) $details.addClass('hidden');	// 没有日志时隐藏
            $details.click(function () {
                var id = $(this).data('id');
                var taskId = $(this).data('task');
                doShowDmLogs(id, taskId);
				
				// 触发轮询
				// 由于日志量较大，全量轮询存在问题，待后续反馈时处理成增量
				// currentLogId = id;
				// logExecutor = setInterval(function () {
					// doShowDmLogs(id, taskId, true);
				// }, 1000);
            });
        });

        // 调整滚动样式
        if (dms.length > 7) {
            $('.dm_logs .td.status').css('padding-left', '3px');
            $('.dm_logs .td.time').css('padding-left', '3px');
            $('.dm_logs .td.details').css('padding-left', '3px');
        }
		
		// 通过大状态停止轮询
		if (dcStatus && hasFinished(dcStatus)) clearInterval(dmExecutor);
    }, doNotShowLoading);
}

// 轮询DM日志
function doShowDmLogs(id, taskId, doNotShowLoading) {
	doAjax('showDmLog', {updateId: getParam('updateId'), id: id, taskId: taskId}, function (data) {
        var logs = [];
        $.each(data.data.split('\n'), function (j, line) {
             logs.push(line);
        });
		showLoading();
		createDialog();
		setLogInContent(logs);
		showDialog();
		hideLoading();

		// 终止轮询条件
		var $status = $('#' + currentLogId);
		if (!$status) return;
		var status = $status.data('status');
		if (hasFinished(status)) clearInterval(logExecutor);
    }, doNotShowLoading);
}


// 静态资源更新详情
function showOtherLogs() {
    formContainer.append('<div class="other_container" id="STATIC_RESOURCE">' +
		'<div class="step_title">' + 
		'<span>静态资源更新</span>' + 
		'<div class="all_time">' + 
		'<span>升级总耗时：</span>' + 
		'<span class="time">未知</span>' + 
		'</div>' + 
		'</div>' +
		
        '<div class="static_logs">' +
        '<div class="tr header">' +
        '<div class="th name">事项</div>' +
        '<div class="th status">升级状态</div>' +
        '<div class="th time">升级耗时</div>' +
        '<div class="th details">操作</div>' +
        '</div>' +
		'</div>' +
        '</div>');

    doShowStatus();
}

// 后端交互，用于轮询
function doShowStatus(doNotShowLoading) {
	var $logs = $('.static_logs');
	doAjax('showStatus', {updateId: getParam('updateId')}, function (data) {
        if (!data.data) return false;
        var info = JSON.parse(data.data);
        if (!info.segments) return false;
		
		// 加载其他步骤
		$logs.find('.body').remove();
        $.each(JSON.parse(info.segments), function (i, item) {
            var processCode = item.processCode;
			var status = item.status;
			
			// 用于标记数据中心升级状态
			if ('DATACENTER_UPDATE' === processCode) {
				$('.dm_logs').attr('data-status', status);
				return;
			}
			
			// 目前只有静态资源
            // if ('STATIC_RESOURCE' !== processCode) return;
            var $tr = $('<div class="tr body">' +
                '<div class="td name" title="' + DESC[processCode] + '">' + DESC[processCode] + '</div>' +
                '<div class="td status" data-status="' + status + '" id="' + processCode + '"><span class="' + STATUS_COLOR[status] + '" title="' + STATUS[status] + '">' + STATUS[status] + '</span></div>' +
                '<div class="td time" data-start="' + item.startTime + '"></div>' +
                '<div class="td details" data-code="' + processCode + '"><span class="blue" title="查看详情">查看详情<span></div>' +
                '</div>');
            $tr.find('.details .blue').click(function () {	// 查看详情
				createDialog();
				showDialog();
				doShowOtherLogs($(this).parent().data('code'));
            });
            $logs.append($tr);
			
			// 列表耗时
			var $time = $tr.find('.time');
			if (hasFinished(status)) $time.attr('data-end', item.modifyTime);
			setConsumingTime($time);
			if (allFinished($logs)) doShowDms(true);
        });
		
		// 总耗时
		$.each(JSON.parse(info.segments), function (i, item) {
			var $allTime = $('#' + item.processCode + ' .step_title .time');
			if ($allTime) {
				$allTime.attr('data-start', item.startTime);
				$allTime.attr('data-end', item.modifyTime);
				setConsumingTime($allTime);
			}
		});
		
		// 通过大状态停止升级轮询
		if (hasFinished(info.status)) {
			clearInterval(otherExecutor);
			clearInterval(dmExecutor);
		}
		
    }, doNotShowLoading);
}

// 创建弹框
function createDialog() {
    var $dialog = $('.dialog').html('<div class="dialog_container">' +
        '<div class="dialog_title">' +
        '<span>日志详情</span>' +
        '<div class="dialog_cancel">×</div>' +
        '</div>' +
        '<div class="dialog_content"></div>' +
        '<div class="dialog_toolbar">' +
        '<button type="button" id="close" class="btn-item">退出</button>' +
        '</div>' +
        '</div>');
		
    // 监听关闭
    $dialog.find('.dialog_cancel, #close').click(function () {
        // $container.fadeOut(function () {
        // $dialog.addClass('hidden');
        // });
        $dialog.addClass('hidden');
        $dialog.empty();
    });
}

// 展示弹框
function showDialog() {
	// 展示动画
	var $dialog = $('.dialog');
    $dialog.removeClass('hidden');
	var $container = $dialog.find('.dialog_container');
    $container.fadeIn(150);
}

// 其他日志详情
function doShowOtherLogs(processCode) {
	doAjax('showSegLogs', {processCode: processCode, updateId: getParam('updateId')}, function (data) {
		setLogInContent(JSON.parse(data.data));
    });
}

// 渲染日志
function setLogInContent(logs) {
	var $content = $('.dialog_content').empty();
	$.each(logs, function (i, item) {
		if (item.indexOf('ERROR') !== -1) {
			$content.append('<div class="line red" style="font-weight: bold;">' + item + '</div>');
		} else {
			$content.append('<div class="line">' + item + '</div>');
		}
	});
}

// 轮询刷新时间
function doUpdateStatus() {
	dmExecutor = setInterval(function () {
		$(".dm_logs .td.time").each(function () {
			setConsumingTime($(this));
		});
		
		// 每5秒轮询一次
		dmCounter++;
		if (0 === dmCounter % 5) doShowDms(true);
	}, 1000);
	
	otherExecutor = setInterval(function () {
		// 列表耗时
		$(".static_logs .td.time").each(function () {
			setConsumingTime($(this));
		});
		
		// 总耗时
		$('.step_title .time').each(function () {
			setConsumingTime($(this));
		});
		
		// 每5秒轮询一次
		otherCounter++;
		if (0 === otherCounter % 5) doShowStatus(true);
	}, 1000);
}

// 时间赋值
function setConsumingTime($td) {
	// 等待状态不显示耗时
	var status = $td.prev(".status").data('status');
	if (status && status === 'WAITING') return;
	
    var start = Number($td.attr('data-start'));
	if (!start) {
		$td.text(covertTimeFromMillis(0));
	} else {
		var end = Number($td.attr('data-end'));
		if (!end) end = new Date().getTime();
		$td.text(covertTimeFromMillis(end - start))
	}
}

// 判断是否完成
function hasFinished(status) {
	return ['SUCCESS', 'FAILURE', 'FAILED', 'TIMEOUT', 'TERMINATED'].indexOf(status) !== -1;
}

// 判断全部完成
function allFinished($logs) {
	var finished = true;
	$logs.find('.td.status').each(function () {
		var status = $(this).data('status');
		if (!hasFinished(status)) finished = false;
	});
	return finished;
}

// 关闭提示
function getCloseTipsListener() {
    $('#cancel').click(function () {
        clearTimeout(errTimer);
        noticeContainer.addClass('hidden')
    })
}

// 抽象请求方法
function doAjax(type, params, successCallback, doNotShowLoading) {
    if (!params) params = {};
    params['type'] = type;
    $.ajax({
        type: 'POST',
        url: 'init/mdbSetting.do',
        data: params,
        beforeSend: function () {
            if (!doNotShowLoading) showLoading();
        },
        complete: hideLoading,
        error: function () {
			// 每10次弹出提示
			errCounter++;
			if (errCounter >= 10) {
				showErrorNotification("无法加载响应数据，可能MC服务中断或正在重启，请刷新重试。");
				errCounter = 0;
			}
		},
        success: function (data) {
            if (data.errorcode === "0") {
                showErrorNotification(data.description_cn || data.description);
                return false
            }

            if (successCallback) successCallback(data);
        }
    })
}

// show loading
function showLoading() {
    $('.mask').removeClass('hidden')
}

// hide loading
function hideLoading() {
    $('.mask').addClass('hidden')
}

// handle error
// function showError(data) {
    // if (data) showErrorNotification(data.description_cn || data.description)
// }

// 报错信息
function showErrorNotification(msg) {
    noticeContainer.find("span").text(msg);
    noticeContainer.find(".icon").text("!");
    noticeContainer.attr("class", "noticeContainer error");
}

// 时间转换
function covertTimeFromMillis(millis) {
    if (!millis || millis < 0) return '0秒';
    var second = Math.floor(millis / 1000);
    if (second < 0) second = 0;
	if (second === 0) return millis + '毫秒';
    var min = Math.floor(second / 60);
    if (min < 0) min = 0;
    var hour = Math.floor(min / 60);
    if (hour < 0) hour = 0;
	
    // return hour + '时' + min % 60 + '分' + second % 60 + '秒';
	var display = second % 60 + '秒';
	if (min > 0) display = min % 60 + '分' + display;
	if (hour > 0) display = hour + '时' + display;
	return display;
}

// param
function getParam(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
    var r = window.location.search.substr(1).match(reg); //获取url中"?"符后的字符串并正则匹配
    var context = "";
    if (r != null) context = decodeURIComponent(r[2]);
    reg = null;
    r = null;
    return context == null || context === "" || context === "undefined" ? "" : context;
}

// 步骤描述字典
var DESC = {
    "APPSTORE_UPDATE": "应用仓库更新",
    "STATIC_RESOURCE": "静态资源更新",
    "DATACENTER_UPDATE": "数据中心升级"
};

// 状态描述字典
var STATUS = {
    "WAITING": "等待",
    "READY": "就绪",
    "RUNNING": "执行中",
    "SUCCESS": "成功",
    "FAILURE": "失败",
    "TIMEOUT": "失败(超时)",
	"TERMINATED": "终止"
};

// 状态颜色
var STATUS_COLOR = {
    "WAITING": "grey",
    "READY": "grey",
    "RUNNING": "blue",
    "SUCCESS": "green",
    "FAILURE": "red",
    "TIMEOUT": "red",
    "TERMINATED": "red"
};